import { Actions, ReimOptions, Action, Handler, Filter, SnapshotFor, Mutation } from './types';
export declare function isReim(store: any): store is Reim;
export declare class Reim<T = any> {
    _name?: string;
    _initial: T;
    _state: T;
    _subscribers: Array<{
        handler: Handler<T>;
        filter: Filter<T>;
        cache: any;
    }>;
    _devTools: any;
    readonly __isReim: symbol;
    readonly name: string;
    constructor(initial?: T, options?: ReimOptions<T>);
    filter<TF extends Filter<T>>(filter?: TF): TF extends (null | undefined) ? T : SnapshotFor<TF, T>;
    set<T, TR extends Reim<T>, TA extends Action<T>>(this: TR & {
        _state: T;
    }, action: TA, ...args: TA extends ((...args: any[]) => Mutation<T>) ? Parameters<TA> : []): void;
    _notify: <TA extends Action<T>, TP extends any[]>(meta: {
        action: TA;
        payload: TP;
    }) => void;
    reset<T, TR extends Reim<T>>(this: TR & {
        _state: T;
    }, initial?: T): any;
    actions<TR extends Reim<T>, T, TA extends Actions<T>>(this: TR & {
        _state: T;
    }, actions?: TA): {
        [Tk in keyof typeof actions]: TA[Tk];
    };
    plugin<TR extends Reim<T>, TP extends ((a?: TR, b?: TR) => any)>(this: TR, plugin: TP): ReturnType<TP> extends (null | undefined | void) ? TR : ReturnType<TP>;
    unsubscribe<TR extends Reim<T>, T>(this: TR & {
        _state: T;
    }, handler: Handler<T>): void;
    subscribe<TR extends Reim<T>, T>(this: TR & {
        _state: T;
    }, handler: Handler<T>, { immediate, filter }?: {
        immediate?: boolean;
        filter?: Filter<T>;
    }): {
        unsubscribe: () => void;
    };
}
declare const reim: <T, TA>(initial: T, options?: ReimOptions<T> & {
    actions?: TA;
}) => Reim<T> & { [Tk in keyof TA]: TA[Tk]; };
export * from './types';
export default reim;
//# sourceMappingURL=index.d.ts.map