import { ReimOptions, State, Getter, Plugin } from './types';
declare type EventListener = (...args: any[]) => void;
declare type EmitterMethod = (type: string, listener: EventListener) => void;
export declare class Store {
    private _name;
    private _initial;
    _state: {
        [index: string]: any;
    };
    private _devTools;
    private _subscribers;
    emit: (type: string, ...args: any[]) => void;
    off: EmitterMethod;
    on: EmitterMethod;
    once: EmitterMethod;
    readonly __isReim: boolean;
    readonly state: {
        [index: string]: any;
    };
    readonly name: string;
    constructor(state?: {}, { name, plugins }?: ReimOptions);
    snapshot(getter?: Getter): any;
    _set: <M extends any>(mutation: M, ...args: M extends (...args: any[]) => (...args: any[]) => any ? Parameters<ReturnType<M>> : M extends (...args: any[]) => any ? any[] : []) => void;
    set: <M extends any>(mutation: M, ...args: M extends (...args: any[]) => (...args: any[]) => any ? Parameters<ReturnType<M>> : M extends (...args: any[]) => any ? any[] : []) => {
        [index: string]: any;
    };
    reset(initial?: any, ...args: any[]): {
        [index: string]: any;
    };
    subscribe(handler: (s: State) => any, { immediate, getter }?: {
        immediate?: boolean;
        getter: Getter;
    }): () => void;
    unsubscribe(handler: (s: State) => any): void;
    plugin(...plugins: Plugin[]): this;
    private _notify;
}
export default function reim<X extends {
    [index: string]: any;
}>(state?: X, options?: ReimOptions): Store;
export declare const toStream: (store: Store, options?: any) => {
    [x: string]: () => any;
    subscribe: (observer?: {
        next: (s: any) => any;
    } | ((s: any) => any)) => {
        unsubscribe: () => void;
    };
};
export * from './types';
//# sourceMappingURL=index1.d.ts.map