import { Draft } from 'immer';
export interface ReimOptions<T> {
    name?: string;
    actions?: Actions<T>;
}
export declare type Mutation<TS> = ((state: Draft<TS> | TS) => void | TS) | Partial<TS>;
export declare type Action<TS> = Mutation<TS> | ((...args: any[]) => Mutation<TS>);
export declare type Actions<TS> = {
    [index: string]: Action<TS>;
};
export declare type Cache<TS, TF> = TF extends ((s: TS) => any) ? ReturnType<TF> : TF extends {
    [index: string]: (s: TS) => TS;
} ? {
    [Tk in keyof TF]: ReturnType<TF[Tk]>;
} : any;
export declare type Filter<TS> = ((s: TS) => any) | {
    [index: string]: ((s: TS) => any);
} | keyof TS;
export declare type SnapshotFor<TF, T> = TF extends ((s: any) => any) ? ReturnType<TF> : TF extends {
    [index: string]: ((s: T) => any);
} ? {
    [Tk in keyof TF]: ReturnType<TF[Tk]>;
} : TF extends keyof T ? T[TF] : T;
export declare type Meta = {
    mutation?: string;
    payload?: any[];
};
export declare type Handler<T> = {
    next: (s: T, meta?: Meta) => any;
} | ((s: T, meta?: Meta) => any);
//# sourceMappingURL=types.d.ts.map